\chapter*{Conclusion}
\addcontentsline{toc}{chapter}{Conclusion}

First, we analysed and described the kernel itself, the problems preventing successful merges for anonymous mappings and all related kernel mechanisms. Next, we determined which functions needed to be modified in order to enable new merges in most of the problematic cases and successfully created a series of patches that solve the individual problems. Finally, the whole solution was tested to verify the merges actually happen when they should happen and speed impact of the changes on the kernel was measured.

%\section*{Analysis}
%\gls{todo}

%\section*{Design}
%\gls{todo}

%\section*{Testing}
%\gls{todo}

%\section*{Results}
%\gls{todo}

\subsection*{Reception}
Judging from the limited responses in the Linux kernel mailing list, it seems that improving merge success rate for anonymous mappings does not have very strong support among developers. This is probably because until now, when a process moved an anonymous mapping, there was not a chance that it could ever merge and still the system as a whole worked well, on top of that new code means added complexity and a risk of introducing bugs into the kernel. In most cases, the unmerged mappings did not cause any serious problems and therefore the inclusion of the patch series as-is in the mainline is improbable, but a chance stands in form of adding this as a conditional feature via e.g. the \verb|madvise()| flag. However, a smaller part of the changes, namely (\fullref{sec:refactor_vma_merge} and \fullref{sec:mremap_expansion}, are already in the process of being merged into the mainline kernel.

\subsection*{Possible users}
The original task was to verify how much better the merging can get, which was motivated by an undisclosed proprietary workload and it will naturally take longer before its developers will test this solution.
%SAP HANA Cloud in some cases exceeds maximum VMA mapping limit. Unfortunately it is proprietary software and as such it is impossible to test. However if this work is in some form included into mainline kernel, they will be able to provide the necessary feedback.

\subsection*{Future extension}
This section contains a list of a few possible extensions dealing with memory mappings that arose during the work on this thesis.

\subsubsection*{Dealing with child and parent processes}
This work solves the vast majority of cases where the merge did not happen previously, however, there is still some space for improvements. The shared processes and respectively their mappings cannot merge in every case. This could be theoretically solved by forcing COW mechanism to copy the shared pages and therefore remove this obstacle.

\subsubsection*{Enabling multi mremap}
One of the problems related to unsuccessful merges is that the \verb|mremap()| system call can only work with a single mapping at a time. When merging does not work as it should, then potentially a single mapping is fragmented into several blocks and if someone wants to move this whole range to another address, he/she has to do it separately for each mapping. This could potentially be solved by adding a new feature to \verb|mremap()|, which would move several mappings at once. This thesis resolves many of the unsuccessful merge cases, however, some of them still remain in the case of shared mappings.

\subsubsection*{Merge collector}
In the mainline kernel, merge is attempted when a mapping is modified and there is a chance it might be possible to merge it. But there are many obstacles preventing merges or making it difficult to check all the conditions necessary like swapping, migration or transparent huge pages. This could possibly be all avoided if the merges did not need to happen immediately after the mapping is changed, but rather at some time in the future. Such a mechanism would be very similar to garbage collectors, however, this change would require significant changes to the kernel merge code and would take a lot of time and effort to debug, validate and persuade the kernel developer community.

\subsubsection*{Overlapping mremap()}
This feature would enable \verb|mremap()| to move a mapping even when the new location would overlap the old one. If this was possible, more flexible operations with mappings would allow users to better organize the mappings and could enable additional merges. This is currently not allowed, because it would require a more complicated approach and probably also a helper memory location, but it is very well possible.

\subsection*{Additional sources}
%\href{https://en.wikipedia.org/wiki/Linux}{Linux Wikipedia}
%\href{https://en.wikipedia.org/wiki/Linux_kernel}{Linux\_kernel Wikipedia}
%\href{https://en.wikipedia.org/wiki/GitHub}{GitHub}
%https://en.wikipedia.org/wiki/Git
\begin{flushleft}

Linux kernel code, comments and Git commit messages\footnote{\cite{Kernel}}\break
Wikipedia\footnote{\cite{Wikipedia}}\break
%Linux kernel documentation in Git \footnote{Linux documentation - \url{https://github.com/torvalds/linux/tree/master/Documentation}}\break
\end{flushleft}




